/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package peteythepervert.com;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.InputStream;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.StandardCopyOption;
import java.util.ArrayList;
import java.util.Properties;
import javax.swing.JFrame;


public class PeteyThePervert  extends JFrame {
public static String USERDIR;
String rootURL;
String loginName;
String loginPassword;
Integer user_id;
String CONFIG_FILE_NAME;
PeteyThePervertFileCloud PeteyAppFrame;
String OS;
String USERCLOUDDIR;
PeteyThePervertConfig PeteyConfig;
 public final String ProgramVersion = "1.4.032";
 String APPID;
 String BROWSERMATORFOLDER;
 ArrayList<String> theseErrors = new ArrayList();
   static final int buffer = 512;
public PeteyThePervert()
  {
   
     APPID = "1";   
 PeteyConfig = new PeteyThePervertConfig();
      CONFIG_FILE_NAME = "petey_the_pervert_config.properties";
        USERDIR = System.getProperty("user.home") + File.separator + "PTPAppFolder";
       BROWSERMATORFOLDER = System.getProperty("user.home") + File.separator + "BrowsermatorAppFolder" + File.separator;
      OS = PeteyConfig.OperatingSystem;
        USERCLOUDDIR = System.getProperty("user.home") + File.separator + "PTPCloudFiles";
 rootURL = "https://www.peteythepervert.com"; 
// rootURL = "http://localhost";
//       String versionstored =  PeteyConfig.getKeyValue("version_main");
//    if (versionstored==null) {versionstored = "";}
//    
//      
//    if (!versionstored.equals(this.ProgramVersion))
//    {
//   ExtractBrowserMatorFiles();
//    }

   PeteyAppFrame = new PeteyThePervertFileCloud(this);
 
  }
  
    public static void main(String[] args) {
 

 //   RunPeteyRun PeteyRun = new RunPeteyRun();
         PeteyThePervert app = new PeteyThePervert(); 
           app.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
  

    
           app.OpenPeteyAppFrame();
  
  
                
        }
 
 public void OpenPeteyAppFrame()
{

   
  PeteyAppFrame.initializeJFXPanel();
  
 //   PeteyAppFrame.ShowFileCloudWindow();
            try
{
  
     FileInputStream input = new FileInputStream(USERDIR + File.separator + CONFIG_FILE_NAME);
    
     PeteyAppFrame.setWindowProps(input);
}
        catch(Exception ex)
        {
          System.out.println("Exception loading config: " + ex.toString() + USERDIR +File.separator + CONFIG_FILE_NAME);  
        }
    PeteyAppFrame.cloudFrame.addWindowListener(new WindowAdapter() {
    @Override
    public void windowClosing(WindowEvent windowEvent) {
    
     PeteyAppFrame.cloudFrame.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
    
    File newconfig = new File(USERDIR + File.separator + CONFIG_FILE_NAME);
     Properties newProps = PeteyConfig.applicationProps;
         Boolean file_exists = false;
       
    try
{
  
     FileInputStream input = new FileInputStream(USERDIR + File.separator + CONFIG_FILE_NAME);
   newProps.load(input);
    
   
      
      newProps.setProperty("main_window_locationY", Integer.toString(windowEvent.getWindow().getY()));
      newProps.setProperty("main_window_locationX", Integer.toString(windowEvent.getWindow().getX()));
      newProps.setProperty("main_window_sizeWidth", Integer.toString(windowEvent.getWindow().getWidth()));
      newProps.setProperty("main_window_sizeHeight", Integer.toString(windowEvent.getWindow().getHeight()));
    
    
    FileWriter writer = new FileWriter(USERDIR + File.separator + CONFIG_FILE_NAME);
    newProps.store(writer, "peteythepervert_settings");
    writer.close();
 
    
} 

    catch (Exception e) {
			System.out.println("Exception: " + e);
		} 
      System.exit(0);
    }
       
    });
            
}
public void saveProps()
{
 // probably don't need   
}
       public void LoadNameAndPassword()
  {
   
     //     Properties applicationProps = new Properties();
     

this.loginName = PeteyConfig.getKeyValue("loginName");
String temppassword = PeteyConfig.getKeyValue("loginPassword");

 if (temppassword==null || "".equals(temppassword))
   {
    this.loginName = "";
    this.loginPassword = "";
   }
   else
       
   {
       
       try
    {
     String machineSN = PeteyConfig.ReturnMachineSerialNumber();
     this.loginPassword = Protector.decryptLocal(temppassword, machineSN);
    }
    catch (Exception ex)
    {
      System.out.println("error decrypting login pw: " + ex.toString());
       
    }

   
   }

   
   
        
  }

   public void SaveNameAndPassword(String in_loginName, String in_Password)
  {
    
    
      this.loginName = in_loginName;
      this.loginPassword = in_Password;

    
 
  String encPassword = "";
  try
      {
           String machineID = PeteyConfig.ReturnMachineSerialNumber();
       encPassword = Protector.encryptLocal(in_Password, machineID);
      }
      catch (Exception ex)
      {
          System.out.println("error encrypting login pw: " + ex.toString());
          
      }
  PeteyConfig.setKeyValue("loginPassword", encPassword);
  PeteyConfig.setKeyValue("loginName", in_loginName);
  
 
  }  
   
    public void LookUpUser(String name, String password)
 {
   String outHTML = "";
     UserParamHash userData = new UserParamHash(name, "", password);
     SendReceiveData thisSession = new SendReceiveData(rootURL + "/get_user_id.php", userData);
  Boolean errorcheck = false;
          try
           {
      outHTML = thisSession.SendParams();           
           }
   catch (Exception ex)
   {
       errorcheck = true;
       System.out.println ("Exception getting user_id : " + ex.toString());
       
   }
   if (outHTML.isEmpty() || "failed".equals(outHTML))
   {
       if (errorcheck)
       {
           this.user_id = -1;
       }
       else
       {
        this.user_id = 0;
       }
       
 }
   else
   {
       try
       {
      this.user_id = Integer.parseInt(outHTML);
       }
       catch (Exception ex)
       {
           System.out.println("Exception parsing user_id int:" + ex.toString());
           this.user_id = -1;
       }
               
   }
 }
     public String RecoverPassword (String email)
 {
     
     UserParamHash userData = new UserParamHash("", email, "");
      SendReceiveData thisSession = new SendReceiveData(rootURL + "/recover.php", userData);
      try
     {
     String outHTML = thisSession.SendParams();
      if ("Success".equals(outHTML))
      {
        return "An email with your password has been sent.";
       
      }
      else
      {
          if (outHTML.contains("failed to send"))
          {
  
          return "Connection to mail server has failed.  Please try again later.";    
          }
          
          else
          {
        return "There is no account registered to " + email;
          }
      }
     
      
     }
     catch (Exception ex)
     {
         
         System.out.println("Exception recovering password: " + ex.toString());
         if (ex.toString().contains("Connection refused"))
         {
             return "Unable to connect to peteythepervert.com";
         }
         else
         {
         return "Unable to recover password.";
         }
     }
   
 }
 public String RegisterUser (Login_Register_Dialog loginDialog, String loginName, String Email, String Password)
 {
    
     
     UserParamHash userData = new UserParamHash(loginName, Email, Password);
     SendReceiveData thisSession = new SendReceiveData(rootURL + "/register.php", userData);
  try
  {
     String outHTML = thisSession.SendParams();
      if ("Success".equals(outHTML))
      {
        
       return "Success";
       
      }
      else
      {
        return "The username and/or email address you have chosen already exists.";
      }
  }
  catch (Exception ex)
  {
      System.out.println ("Exception sending params register: " + ex.toString());
  }
     
     
return "Unable to connect petey the pervert.com.";
  
 }
 

  public void WriteResource (String dirname, String filename)
 {
       File driver_directory = new File(BROWSERMATORFOLDER + dirname);
        if (!driver_directory.exists()) {
            if (driver_directory.mkdir()) {
                System.out.println("Directory is created!");
            } else {
                System.out.println("Failed to create directory!");
            }
        }
        InputStream inStream;
        if ("".equals(dirname))
        {
     inStream = PeteyThePervert.class.getResourceAsStream("/peteythepervert/com/Resources/" + filename);
          
        }
        else
        {
     inStream = PeteyThePervert.class.getResourceAsStream("/peteythepervert/com/Resources/" + dirname + "/" + filename);
        }
         File newFile;
        if ("".equals(dirname))
        {
         newFile = new File(BROWSERMATORFOLDER  + filename);     
        }
        else
        {
     newFile = new File(BROWSERMATORFOLDER + dirname + File.separator + filename); 
        }
          Path BMAppPath = newFile.toPath();

try
{
   if (inStream != null) {
 
                Files.copy(inStream, BMAppPath,StandardCopyOption.REPLACE_EXISTING);
                inStream.close();
                setPermissions(newFile);
            }
   else
   {
   
    
   }
   
}
catch (Exception ex)
{
    System.out.println(ex.toString());
    theseErrors.add(ex.toString());
}  

 }
   public void setPermissions(File thisFile)
         {
             
          
           if (!thisFile.canExecute())
           {
            thisFile.setExecutable (true, true);
           }
           
         }
}
